package info.textgrid.middleware;

import java.io.IOException;
import java.text.ParseException;
import java.util.Hashtable;
import java.util.Map;

import javax.xml.datatype.DatatypeConfigurationException;

import info.textgrid.middleware.oaipmh.GetRecordType;
import info.textgrid.middleware.oaipmh.HeaderType;
import info.textgrid.middleware.oaipmh.ListRecordsType;
import info.textgrid.middleware.oaipmh.ResumptionTokenType;

public class OpenAireRecordList extends RecordListDelivererAbstract {
	
	//protected static Map<String, Integer> cursorCollector = new Hashtable<String, Integer>();
	
	
	private String rangeField;
	private String formatField;
	private String formatToFilter;
	private int searchResponseSize;
	private long resultSize;
	private boolean foundItems;
	public ResumptionTokenType resTokenForResponse;
	
	public OpenAireRecordList(boolean textgrid, boolean dariah) {
		super(textgrid, dariah);
	}

	
	public ListRecordsType getRecords(String from, String to, String set, String resumptionToken){
		ListRecordsType openAireRecordList = new ListRecordsType();
		OpenAireRecord openAireRecord;

		for(String uri : getUriList(from, to, set, resumptionToken)) {			
			try {
				try {
					openAireRecord = new OpenAireRecord(true, false);
					GetRecordType grt = openAireRecord.getRecordById(uri.replace("textgrid:", ""));
					openAireRecordList.getRecord().add(grt.getRecord());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
			} catch (ParseException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			
			} catch (DatatypeConfigurationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}			
		}		
        
        //if (resTokenForResponse != null) {
		//System.out.println("RESTOKEN: ");
		//System.out.println(getResTokenForResponse().getValue());
		//System.out.println(getResumptionToken());
		//resTokenForResponse = OAIPMHUtilities.getResumptionToken(
	    //          94146, resumptionToken, cursorCollector, scrollID, this.searchResponseSize, i)		
        	openAireRecordList.setResumptionToken(getResTokenForResponse());
        //}
		
		return openAireRecordList;
	}

	@Override
	public HeaderType setHeader(String set, String headerIdentifier, String setSpec) {
		// TODO Auto-generated method stub
		return null;
	}
	
	  //GETTER AND SETTER
	  
		public String getRangeField() {
			return rangeField;
		}
		
		public void setRangeField(String rangeField) {
			this.rangeField = rangeField;
		}
		
		
		/**
		 * @param formatToFilter
		 */
		public void setFormatToFilter(String formatToFilter) {
		  this.formatToFilter = formatToFilter;
		}
		
		/**
		 * @param formatField
		 */
		public void setFormatField(String formatField) {
		  this.formatField = formatField;
		}

		public int getSearchResponseSize() {
			return searchResponseSize;
		}

		public void setSearchResponseSize(int searchResponseSize) {
			this.searchResponseSize = searchResponseSize;
		}

		public long getResultSize() {
			return resultSize;
		}

		public void setResultSize(long resultSize) {
			this.resultSize = resultSize;
		}

		public boolean isFoundItems() {
			return foundItems;
		}

		public void setFoundItems(boolean foundItems) {
			this.foundItems = foundItems;
		}


		/*public ResumptionTokenType getResTokenForResponse() {
			return resTokenForResponse;
		}

		public void setResTokenForResponse(ResumptionTokenType resTokenForResponse) {
			this.resTokenForResponse = resTokenForResponse;
		}*/

}
